//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8

//
//
//
//
//

extern string HullPeriods      = "5;8;13;21;34;55;89;144";
extern int    HullPrices       = PRICE_CLOSE;
extern color  StartColor       = Lime;
extern color  EndColor         = PaleVioletRed;
extern int    LinesWidth       = 1;
extern bool   ShowArrows       = false;
extern string ArrowsIdentifier = "hullCrosses";

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];

//
//
//
//
//

double workAverages[][8];
double workTrends[][64];
double workPeriods[];
double workColors[];
double work[][8];
int    workSize;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   HullPeriods = StringTrimLeft(StringTrimRight(HullPeriods));
   if (StringSubstr(HullPeriods,StringLen(HullPeriods),1) != ";")
                    HullPeriods = StringConcatenate(HullPeriods,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(HullPeriods,";",s);
         int period;
         string current;
            while (i > 0)
            {
               current = StringSubstr(HullPeriods,s,i-s);
               period  = StrToInteger(current);
               if (period > 0) {
                     ArrayResize(workColors, ArraySize(workColors) +1);
                     ArrayResize(workPeriods,ArraySize(workPeriods)+1);
                                 workPeriods[ArraySize(workPeriods)-1] = period; }
                                 s = i + 1;
                                     i = StringFind(HullPeriods,";",s);
            }

         //
         //
         //
         //
         //
                     
         ArraySort(workPeriods);
            workSize = MathMin(ArraySize(workPeriods),8);
                       for (i=0; i<workSize; i++) workColors[i] = gradientColor(i,workSize,StartColor,EndColor);
                       for (   ; i<8       ; i++) SetIndexStyle(i,DRAW_NONE);
         if (workSize>0) { SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_LINE,EMPTY,LinesWidth,workColors[0]); }
         if (workSize>1) { SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_LINE,EMPTY,LinesWidth,workColors[1]); }
         if (workSize>2) { SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_LINE,EMPTY,LinesWidth,workColors[2]); }
         if (workSize>3) { SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_LINE,EMPTY,LinesWidth,workColors[3]); }
         if (workSize>4) { SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_LINE,EMPTY,LinesWidth,workColors[4]); }
         if (workSize>5) { SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_LINE,EMPTY,LinesWidth,workColors[5]); }
         if (workSize>6) { SetIndexBuffer(6,buffer7); SetIndexStyle(6,DRAW_LINE,EMPTY,LinesWidth,workColors[6]); }
         if (workSize>7) { SetIndexBuffer(7,buffer8); SetIndexStyle(7,DRAW_LINE,EMPTY,LinesWidth,workColors[7]); }
   
   //
   //
   // 
   //
   //
   
   return(0);
}
int deinit()
{
   if (ShowArrows) deleteArrows(); return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,k,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(workTrends,0) != Bars) { ArrayResize(workTrends,Bars); ArrayResize(workAverages,Bars); ArrayResize(work,Bars); }

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      for (k=0;   k<workSize; k++) workAverages[r][k] = iHull(i,r,k,workPeriods[k],HullPrices);
      for (k=0;   k<workSize; k++)
      for (j=k+1; j<workSize; j++)
      {
         int ind = k*8+j;
               workTrends[r][ind] = workTrends[r-1][ind];
                  if (workAverages[r][k] > workAverages[r][j]) workTrends[r][ind]= 1;
                  if (workAverages[r][k] < workAverages[r][j]) workTrends[r][ind]=-1;
                  if (ShowArrows)
                  {
                     ObjectDelete(ArrowsIdentifier+":"+Time[i]+":"+ind);
                     if (workTrends[r][ind] != workTrends[r-1][ind])
                     if (workTrends[r][ind] == 1)
                           createArrow(Time[i],ind,workColors[k],workAverages[r][j],i,true);
                     else  createArrow(Time[i],ind,workColors[k],workAverages[r][j],i,false);
                  }
      }
   
      //
      //
      //
      //
      //
      
      if (workSize>0) buffer1[i] = workAverages[r][0];
      if (workSize>1) buffer2[i] = workAverages[r][1];
      if (workSize>2) buffer3[i] = workAverages[r][2];
      if (workSize>3) buffer4[i] = workAverages[r][3];
      if (workSize>4) buffer5[i] = workAverages[r][4];
      if (workSize>5) buffer6[i] = workAverages[r][5];
      if (workSize>6) buffer7[i] = workAverages[r][6];
      if (workSize>7) buffer8[i] = workAverages[r][7];
   }
   
   //
   //
   //
   //
   //
   
   return(0);         
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iHull(int i, int r, int k, int period, int price)
{
   int HalfPeriod = MathFloor(period/2);
   int HullPeriod = MathFloor(MathSqrt(period));

      work[r][k] = 2.0*iMA(NULL,0,HalfPeriod,0,MODE_LWMA,price,i)-iMA(NULL,0,period ,0,MODE_LWMA,price,i);

      //
      //
      //
      //
      //
      
      double sum  = 0;
      double sumw = 0;
            for(int j=0; j<HullPeriod && (r-j)>=0; j++)
            {
               double weight = HullPeriod-j;
                      sumw  += weight;
                      sum   += weight*work[r-j][k];  
            }
      if (sumw!=0)
            return(sum/sumw);
      else  return(EMPTY_VALUE);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void createArrow(datetime time, int add, color theColor, double price, int i, bool up)
{
   string name = ArrowsIdentifier+":"+time+":"+add;
   double gap  = iATR(NULL,0,10,i)/10.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,time,0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
         {
               ObjectSet(name,OBJPROP_ARROWCODE,241);
               ObjectSet(name,OBJPROP_PRICE1,price-gap);
         }               
         else
         {
               ObjectSet(name,OBJPROP_ARROWCODE,242);
               ObjectSet(name,OBJPROP_PRICE1,price+gap);
         }               
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = ArrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}